package net.duiker101.opendungeon;

import javax.microedition.khronos.opengles.GL10;

import org.anddev.andengine.entity.IEntity;
import org.anddev.andengine.entity.modifier.AlphaModifier;
import org.anddev.andengine.entity.modifier.IEntityModifier;
import org.anddev.andengine.entity.modifier.MoveModifier;
import org.anddev.andengine.entity.sprite.TiledSprite;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.texture.region.TiledTextureRegion;
import org.anddev.andengine.util.modifier.IModifier;

import android.graphics.Point;

public class Brick {
	
	private Game mGame;
	private BricksField mField;
	private TiledSprite mSprite;
	
	public int mId;
	
	public int mType=0;
	
	private float mX=0;
	private float mY=0;
	
	private float mXOffset=0;
	private float mYOffset=0;
	
	public boolean mMoving = false;
	public boolean mReqMove = false;
	public boolean mDestroying = false;
	public boolean mDestroyed = true; 
	
	public Brick(Game pGame,BricksField pField,TiledTextureRegion pRegion,int pId,float pX,float pY,float pW,float pH,float pXOffset,float pYOffset){
		this.mGame=pGame;
		this.mField=pField;
		double r=Math.random()*6;
		this.mType=(int)r;
		this.mId=pId;
		this.mSprite = new TiledSprite(0, 0,pRegion.deepCopy()){
			
			@Override
			public boolean onAreaTouched(TouchEvent pEvent,float pTouchAreaLocalX, float pTouchAreaLocalY) {
				if(mMoving==true)
					return true;
				
				int x=getPos().x;
				int y=getPos().y;
				mField.touch(pEvent,mId,x,y);
				return true;
			}
			
		};
		this.mSprite.setBlendFunction(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA);
		this.mSprite.setSize(pW-6, pH-6);
		this.mSprite.setZIndex(50);
		
		this.mX=pX;
		this.mY=pY;
		this.mXOffset=pXOffset;
		this.mYOffset=pYOffset;
		
		
		this.mSprite.setPosition(this.mX*pW+this.mXOffset, this.mY*pH+this.mYOffset);
		this.mGame.getEngine().getScene().attachChild(this.mSprite);
		this.mGame.getEngine().getScene().registerTouchArea(this.mSprite);
		this.mSprite.setCurrentTileIndex(this.mType);
	}
	
	public Point getPos(){
		int x=(int) ((this.mSprite.getX()-mXOffset)/this.mSprite.getWidth());
		int y=(int) ((this.mSprite.getY()-mYOffset)/this.mSprite.getHeight());
		Point p=new Point(x,y);
		return p;
	}
	
	public void setType(int pType){
		this.mType=pType;
	}

	public void setPos(final int pX,final int pY){
		float xT=pX*mSprite.getWidth()+mXOffset;
		float yT=pY*mSprite.getWidth()+mYOffset;
		this.mSprite.setPosition(xT, yT);
	}
	
	public void moveTo(final int pX,final int pY){
		float xF=mSprite.getX();
		float xT=pX*mSprite.getWidth()+mXOffset+3+6*pX;
		float yF=mSprite.getY();
		float yT=pY*mSprite.getWidth()+mYOffset+3+6*pY;
		
		this.mMoving=true;
		this.mSprite.registerEntityModifier(new MoveModifier(.3f,xF,xT,yF,yT,new IEntityModifier.IEntityModifierListener() {
			@Override
			public void onModifierStarted(IModifier<IEntity> pModifier, IEntity pItem) {
			}
			
			@Override
			public void onModifierFinished(IModifier<IEntity> pModifier, IEntity pItem) {
				mMoving=false;
				mReqMove=false;
			}
		}));
	}
	
	public void destroy(final int fX,final int fY,final int tX,final int tY){
		this.mDestroying=true;
		this.mMoving=true;
		
		this.mSprite.registerEntityModifier(new AlphaModifier(.3f, 1.0f, 0.0f, new IEntityModifier.IEntityModifierListener() {
			
			@Override
			public void onModifierStarted(IModifier<IEntity> pModifier, IEntity pItem) {}
			
			@Override
			public void onModifierFinished(IModifier<IEntity> pModifier, IEntity pItem) {
				mDestroying=false;
				mMoving=false;
				double r=Math.random()*6;
				mType=(int)r;

				mSprite.setCurrentTileIndex(mType);
				mField.setAfterDestory(fX,fY,tX,tY);
				mSprite.setPosition(tX*mSprite.getWidth()+mXOffset+3+6*tX, tY*mSprite.getHeight()+mYOffset+3+6*tY);
				mSprite.setAlpha(1.0f);
			}
		}));
	}
	
}
