package net.duiker101.opendungeon;

import org.anddev.andengine.engine.Engine;
import org.anddev.andengine.engine.camera.Camera;
import org.anddev.andengine.engine.options.EngineOptions;
import org.anddev.andengine.engine.options.EngineOptions.ScreenOrientation;
import org.anddev.andengine.engine.options.resolutionpolicy.RatioResolutionPolicy;
import org.anddev.andengine.entity.scene.Scene;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;
import org.anddev.andengine.opengl.texture.region.TextureRegion;
import org.anddev.andengine.ui.activity.BaseGameActivity;


import android.os.Bundle;

public class Game extends BaseGameActivity {
	
	public static int CAMERA_WIDTH = 480;
	public static int CAMERA_HEIGHT = 800;
	public Camera mCamera;
	public Scene mScene;
	
	public BricksField mField;


	private BitmapTextureAtlas bgTexture;
	public TextureRegion bgdregion;
	public TextureRegion bguregion;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        mField=new BricksField(this);
        
    }

	@Override
	public Engine onLoadEngine() {
		this.mCamera = new Camera(0, 0, CAMERA_WIDTH, CAMERA_HEIGHT);
		return new Engine(new EngineOptions(true, ScreenOrientation.PORTRAIT, new RatioResolutionPolicy(CAMERA_WIDTH, CAMERA_HEIGHT), this.mCamera));
	}


	@Override
	public void onLoadResources() {
		bgTexture = new BitmapTextureAtlas(1024, 1024, TextureOptions.BILINEAR_PREMULTIPLYALPHA);
    	bgdregion=BitmapTextureAtlasTextureRegionFactory.createFromAsset(bgTexture, this, "bgd.png",0,0);
    	bguregion=BitmapTextureAtlasTextureRegionFactory.createFromAsset(bgTexture, this, "bgu.png",490,0);
        this.getEngine().getTextureManager().loadTextures(bgTexture);
        
		mField.loadResource();
	}
	
	
	@Override
	public Scene onLoadScene() {
		mScene = new Scene();
		mScene.setTouchAreaBindingEnabled(true);
		
		return mScene;
	}
	
    
	@Override
	public void onLoadComplete() {
		Sprite bgu = new Sprite(0, 0, bguregion);
		Sprite bgd = new Sprite(0, 0, bgdregion);
		mScene.attachChild(bgd);
		mField.loadScene();
		mField.generate();
		mScene.attachChild(bgu);
	}

}